Bug 468285 - Review Request: gobject-introspection
Review Request: gobject-introspection
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Owen Taylor
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-23 17:23 EDT by Colin Walters
Modified: 2013-07-24 17:34 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-12-11 17:18:49 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
otaylor: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Colin Walters 2008-10-23 17:23:47 EDT
SRPM: http://cdn.verbum.org/gobject-introspection-0.5.0-1.svn20081023.r801.fc10.src.rpm
SPEC: http://cdn.verbum.org/gobject-introspection.spec

%description
GObject Introspection can scan C header and source files in order to
generate metadata "typelib" files.  It also provides an API to examine
typelib files, useful for creating language bindings among other
things.
Comment 1 Owen Taylor 2008-10-25 11:44:52 EDT
Taking review
Comment 2 Owen Taylor 2008-10-25 13:02:00 EDT
Look pretty good. 

 - Some minor specfile issues
 - License doesn't match contents
 - Fails in mock because of autogen.sh usage

See details below. Also would suggest Summary and Description would be better if the word "Metadata" was removed from each (no replacement necessary.)

[*] OK or not applicable
[X] Problem
[-] Not checked

Musts
======
[*] rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint  gobject-introspection.spec 
gobject-introspection.spec: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 6)
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

Looks clean.

[*] The package must be named according to the  Package Naming Guidelines .
[*] The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines .
[X] MUST: The package must meet the Packaging Guidelines .

I would suggest using the python_sitelib magic from http://fedoraproject.org/wiki/Packaging/Python

%install is supposed to remove the buildroot first - see http://fedoraproject.org/wiki/Packaging/Guidelines

[*] The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[X] The License field in the package spec file must match the actual license.

The license tag for the package is LGPLv2+, the COPYING file in gobject-introspection is GPL3, some of the source files are GPLv2+, some LGPLv2+.

[*] If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

(See above)

[*] The spec file must be written in American English.
[*] The spec file for the package MUST be legible. If the reviewer is unable to read the spec file, it will be impossible to perform a review. Fedora is not the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
[X] The sources used to build the package must match the upstream source, as provided in the spec URL.

SVN snapshot, which is OK, but source URL is a weird non-real URL

Source0:        http://svn.gnome.org/svn/gobject-introspection/gobject-introspection-%{version}-20081023-r801.tar.gz

http://fedoraproject.org/wiki/Packaging/SourceURL has some suggestion

[*] The package must successfully compile and build into binary rpms on at least one supported architecture.
[*] If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. 
[*] All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[*] The spec file MUST handle locales properly. 
[*] Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[*] If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[*] A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. Refer to the Guidelines for examples.
[*] A package must not contain any duplicate files in the %files listing.
[*] Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[*] Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ).
[*] Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[*] The package must contain code, or permissable content. This is described in detail in the code vs. content section of Packaging Guidelines .
[*] Large documentation files should go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity)
[*] If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[*] Header files must be in a -devel package.
[*] Static libraries must be in a -static package.
[*] Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[*] If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[*] In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[*] Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. This is described in detail in the desktop files section of the Packaging Guidelines . If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[*] Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[X] At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
See above
[*] All filenames in rpm packages must be valid UTF-8.

Should
======
[*] If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[*] The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[X] The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.

Spec file runs autogen.sh which requires gnome-common, which is not in BuildRequires. (And presumably many other packages like autoconf, gnome-common is just the first one.) autogen.sh should not be necessary for a 'make distcheck' output?

[-] The package should compile and build into binary rpms on all supported architectures.
[-] The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[*] If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[*] Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[*] The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[*] If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. Please see File Dependencies in the Guidelines for further information.
Comment 3 Colin Walters 2008-10-31 18:12:38 EDT
Thanks for the review, Owen.  This should address the issues:

http://cdn.verbum.org/gobject-introspection-0.6.0-1.fc10.src.rpm
Comment 4 Colin Walters 2008-10-31 18:16:06 EDT
(Except for the license bit, tracking that down upstream now)
Comment 5 Colin Walters 2008-11-03 12:56:20 EST
License is resolved upstream: http://svn.gnome.org/svn/gobject-introspection/trunk/COPYING
Comment 6 Owen Taylor 2008-11-03 13:02:55 EST
Looks good. Make sure to fix the License tag to reflect the dual licensing.
Comment 7 Dennis Gilmore 2008-11-03 14:13:46 EST
unsetting cvs admin request since there is no cvs admin request here
Comment 8 Colin Walters 2008-11-03 14:26:05 EST
New Package CVS Request
=======================
Package Name: gobject-introspection
Short Description: Metadata reflection system for GObject-based libraries
Owners: walters otaylor
Branches: F-9
InitialCC:
Comment 9 Michel Alexandre Salim 2010-12-12 18:22:22 EST
If Colin has no objection, I'd like to branch this for EL-6 so that I can get libgee built. Colin, Owen, would you want to maintain the branch or should I?
Comment 10 Owen Taylor 2010-12-13 09:49:39 EST
(In reply to comment #9)
> If Colin has no objection, I'd like to branch this for EL-6 so that I can get
> libgee built. Colin, Owen, would you want to maintain the branch or should I?

Does libgee have a --disable-introspection option? Because core packages like GTK+ are built without introspection support in RHEL-6, I don't really see it as possible to create EPEL packages that introduce introspection. You could build gobject-introspection and maybe a few things like libgee that have no dependencies, but beyond that it would get pretty difficult.
Comment 11 Michel Alexandre Salim 2010-12-18 15:19:06 EST
It comes shipped with a .gir file, so I believe it supports introspection but does not require it. I'll just %exclude the file on EL6 if that's the more consistent approach.
Comment 12 Orion Poplawski 2013-07-24 17:28:25 EDT
Michel - did you ever get anywhere with the EL6 support?

I've been poking at this in a vain attempt to get a recent upower on el6 built.  It seems that 0.9.5 is the latest that I am able to build on EL6.  With that I seem to be able to build upower 0.9.18 with a little hacking to think it can.  No idea if it actually works though.

Would it be worth it to get these two items into EPEL6?
Comment 13 Orion Poplawski 2013-07-24 17:34:21 EDT
CCing some others for input.

Note You need to log in before you can comment on or make changes to this bug.